<template>
  <div id="q-app">
    <router-view />
  </div>
</template>

<script>
import { userSession, blockstack } from "boot/blockstack";
import { mapActions } from "vuex";

export default {
  name: "App",
  async mounted() {
    if (userSession.isUserSignedIn()) {
      this.setProfile();
    } else if (userSession.isSignInPending()) {
      userSession.handlePendingSignIn().then(() => {
        this.setProfile();
        window.location = window.location.href.split("?")[0];
      });
    }
    this.$q.loading.show();
    this.init();
    this.$q.loading.hide();
    this.$router.push("/webby");
  },
  methods: {
    ...mapActions({
      init: "init",
      setUser: "setUser",
    }),
    async setProfile() {
      let userData = userSession.loadUserData();
          const profile = await blockstack.lookupProfile(userData.username);

          if (profile.hasOwnProperty("image")) {
            this.userAvatar = profile.image[0].contentUrl;
          }
          if (profile.hasOwnProperty("name")) {
            this.userName = profile.name;
          } else {
            this.userName = userData.decentralizedID;
          }

          const update = {
            id: userData.username,
            name: this.userName,
            avatar: this.userAvatar,
            authenticated: true
          };
          // this.setUser(user);
          this.setUser(update);
    },
  },
};
</script>

<style></style>
